<template>
  <div ref="el" class="wraper">
    <div 
      class="image" 
      :style="{
        transform: `translateY(${imageOffset}px)`, 
        backgroundImage: `url(${image})`,
        width: this.width,
        height: this.height
        }">
    </div>
    <div 
      :class="{box: true, rtl}" 
      :style="{
        width: this.width,
        height: this.height
      }">
    </div>
  </div>
</template>

<script>
export default {
  name: "AnimatedImage",
  data() {
    return {
      imageOffset: 0,
      prevScrollY: 0
    }
  },
  props: {
    image: {
      type: String,
      required: true
    },
    width: {
      type: String,
      default: '300px'
    },
    height: {
      type: String,
      default: '500px'
    },
    speed: {
      type: Number,
      default: 1/6
    },
    originOffset: {
      type: Number,
      default: 100
    },
    rtl: {
      type: Boolean,
      default: false
    }
  },
  methods: {
    updateOffset() {
      this.imageOffset = this.$refs.el.getBoundingClientRect().top / this.calculatedSpeed - this.originOffset / this.calculatedSpeed;
    }
  },
  computed: {
    calculatedSpeed() {
      return 1 / this.speed;
    }
  },
  mounted() {
    window.addEventListener('scroll', this.updateOffset);
    this.updateOffset();
  },
  beforeDestroy() {
    window.removeEventListener('scroll', this.updateOffset);
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.wraper
  direction ltr
  position relative

.box
  background-color $primary
  position absolute
  z-index 1
  top -2rem
  left -2rem
  &.rtl
    left auto 
    right -2rem

.image
  position relative
  z-index 2
  transition all .2s ease-out
  background-size cover
  background-position center
  box-shadow 0 .75rem 2rem rgba(black, .5)
</style>